//JafoNoksy's code
#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pll = pair<ll, ll>;
#define ve vector
#define pb push_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define int ll
#define F first
#define S second
#pragma GCC optimize "O2"

template<class A>
istream &operator>>(istream &in, ve<A> &x) {
    for (auto &el: x)
        in >> el;
    return in;
}

template<class A>
ostream &operator<<(ostream &out, ve<A> x) {
    for (auto &el: x)
        out << el << ' ';
    return out << '\n';
}

struct segtree {
    ve<int> t, s;
    int n;

    segtree(ve<int> &a) {
        n = a.size();
        t.assign(4 * n, 0);
        s.assign(4 * n, 2);
        build(0, 0, n, a);
    }

    void build(int v, int l, int r, ve<int> &a) {
        if (l + 1 == r) {
            t[v] = a[l];
            return;
        }
        int m = (l + r) / 2;
        build(2 * v + 1, l, m, a);
        build(2 * v + 2, m, r, a);
    }

    void push(int v, int l, int r) {
        if (s[v] == 2)
            return;
        if (l + 1 == r)
            t[v] = s[v];
        else {
            s[2 * v + 1] = s[2 * v + 2] = s[v];
            s[v] = 2;
        }
    }

    void change(int v, int l, int r, int _l, int _r, int val) {
        push(v, l, r);
        if (l >= _r || _l >= r)
            return;
        if (_l <= l && r <= _r) {
            s[v] = val;
            push(v, l, r);
            return;
        }
        int m = (l + r) / 2;
        change(2 * v + 1, l, m, _l, _r, val);
        change(2 * v + 2, m, r, _l, _r, val);
    }

    void get(int v, int l, int r, ve<int> &a) {
        push(v, l, r);
        if (l + 1 == r) {
            a[l] = t[v];
            return;
        }
        int m = (l + r) / 2;
        get(2 * v + 1, l, m, a);
        get(2 * v + 2, m, r, a);
    }
};

void obh(int v, ve<ve<int>> &g, ve<int> &t, ve<int> &ans, int &cnt) {
    if (v == -1)
        return;
    if (t[v] == 1) {
        for (auto &u: g[v]) {
            obh(u, g, t, ans, cnt);
        }
        ans[v] = cnt++;
        return;
    }
    if (t[v] == 0) {
        if (g[v].size())
            obh(g[v][0], g, t, ans, cnt);
        ans[v] = cnt++;
        if (g[v].size() >= 2)
            obh(g[v][1], g, t, ans, cnt);
        return;
    }
    ans[v] = cnt++;
    for (auto &u: g[v]) {
        obh(u, g, t, ans, cnt);
    }

}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, q;
    cin >> n >> q;
    ve<ve<int>> g(n);
    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        g[i].pb(x - 1);
        g[i].pb(y - 1);
    }
    ve<int> t(n, -1);
    segtree T(t);
    ve<int> ans(n, 0);
    int cnt = 1;
    obh(0, g, t, ans, cnt);
    cnt = 1;
    int cnt_f = 0;
    bool flag = 1;
    while (q--) {
        int type;
        cin >> type;
        cnt_f += (type == 1);
        if (type == 1) {
            int l, r, x;
            cin >> l >> r  >> x;
            T.change(0, 0, n, l-1, r, x);
            flag = 0;
        } else {
            int i;
            cin >> i;
            if (!flag) {
                T.get(0, 0, n, t);
                obh(0, g, t, ans, cnt);
                cnt = 1;
                flag = 1;
            }
            cout << ans[i-1] << '\n';
        }
    }
}