//JafoNoksy's code
#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pll = pair<ll, ll>;
#define ve vector
#define pb push_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define int ll
#define F first
#define S second
#pragma GCC optimize "O2"

template<class A>
istream &operator>>(istream &in, ve<A> &x) {
    for (auto &el: x)
        in >> el;
    return in;
}

template<class A>
ostream &operator<<(ostream &out, ve<A> x) {
    for (auto &el: x)
        out << el << ' ';
    return out << '\n';
}

struct segtree {
    ve<int> t, s;
    int n;

    segtree(ve<int> &a) {
        n = a.size();
        t.assign(4 * n, 0);
        s.assign(4 * n, 2);
        build(0, 0, n, a);
    }

    void build(int v, int l, int r, ve<int> &a) {
        if (l + 1 == r) {
            t[v] = a[l];
            return;
        }
        int m = (l + r) / 2;
        build(2 * v + 1, l, m, a);
        build(2 * v + 2, m, r, a);
    }

    void push(int v, int l, int r) {
        if (s[v] == 2)
            return;
        if (l + 1 == r)
            t[v] = s[v];
        else {
            s[2 * v + 1] = s[2 * v + 2] = s[v];
            s[v] = 2;
        }
    }

    void change(int v, int l, int r, int _l, int _r, int val) {
        push(v, l, r);
        if (l >= _r || _l >= r)
            return;
        if (_l <= l && r <= _r) {
            s[v] = val;
            push(v, l, r);
            return;
        }
        int m = (l + r) / 2;
        change(2 * v + 1, l, m, _l, _r, val);
        change(2 * v + 2, m, r, _l, _r, val);
    }

    void get(int v, int l, int r, ve<int> &a) {
        push(v, l, r);
        if (l + 1 == r) {
            a[l] = t[v];
            return;
        }
        int m = (l + r) / 2;
        get(2 * v + 1, l, m, a);
        get(2 * v + 2, m, r, a);
    }

    int get_i(int v, int l, int r, int i) {
        push(v, l, r);
        if (l > i || r <= i)
            return 0;
        if (l + 1 == r)
            return t[v];
        int m = (l + r) / 2;
        return get_i(2 * v + 1, l, m, i) + get_i(2 * v + 2, m, r, i);
    }
};
struct segtree2 {
    ve<int> t, s;
    int n;

    segtree2(ve<int> &a) {
        n = a.size();
        t.assign(4 * n, 0);
        s.assign(4 * n, 0);
        build(0, 0, n, a);
    }

    void build(int v, int l, int r, ve<int> &a) {
        if (l + 1 == r) {
            t[v] = a[l];
            return;
        }
        int m = (l + r) / 2;
        build(2 * v + 1, l, m, a);
        build(2 * v + 2, m, r, a);
    }

    void push(int v, int l, int r) {
        if (s[v] == 0)
            return;
        if (l + 1 == r) {
            t[v] += s[v];
            s[v] = 0;
        }
        else {
            s[2 * v + 1] += s[v];
            s[2 * v + 2] += s[v];
            s[v] = 0;
        }
    }

    void change(int v, int l, int r, int _l, int _r, int val) {
        if (l >= r)
            return;
        push(v, l, r);
        if (l >= _r || _l >= r)
            return;
        if (_l <= l && r <= _r) {
            s[v] = val;
            push(v, l, r);
            return;
        }
        int m = (l + r) / 2;
        change(2 * v + 1, l, m, _l, _r, val);
        change(2 * v + 2, m, r, _l, _r, val);
    }

    void get(int v, int l, int r, ve<int> &a) {
        push(v, l, r);
        if (l + 1 == r) {
            a[l] = t[v];
            return;
        }
        int m = (l + r) / 2;
        get(2 * v + 1, l, m, a);
        get(2 * v + 2, m, r, a);
    }

    int get_i(int v, int l, int r, int i) {
        push(v, l, r);
        if (l > i || r <= i)
            return 0;
        if (l + 1 == r)
            return t[v];
        int m = (l + r) / 2;
        return get_i(2 * v + 1, l, m, i) + get_i(2 * v + 2, m, r, i);
    }
};

ve<int> Left(2e5, 0), Right(2e5, 0);
void obh(int v, ve<ve<int>> &g, ve<int> &t, ve<int> &ans, int &cnt) {
    if (v == -1)
        return;
    if (t[v] == 1) {
        int k = cnt;
        obh(g[v][0], g, t, ans, cnt);
        Left[v] = cnt-k;
        k = cnt;
        obh(g[v][1], g, t, ans, cnt);
        Right[v] = cnt-k;
        ans[v] = cnt++;
        return;
    }
    if (t[v] == 0) {
        int k = cnt;
        obh(g[v][0], g, t, ans, cnt);
        Left[v] = cnt-k;
        ans[v] = cnt++;
        k = cnt;
        obh(g[v][1], g, t, ans, cnt);
        Right[v] = cnt-k;
        return;
    }
    ans[v] = cnt++;
    int k = cnt;
    obh(g[v][0], g, t, ans, cnt);
    Left[v] = cnt-k;
    k = cnt;
    obh(g[v][1], g, t, ans, cnt);
    Right[v] = cnt-k;
}



int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, q;
    cin >> n >> q;
    ve<ve<int>> g(n);
    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        g[i].pb(x - 1);
        g[i].pb(y - 1);
    }
    ve<int> t(n, -1);
    segtree T(t);
    ve<int> ans(n, 0);

    int cnt = 1;
    obh(0, g, t, ans, cnt);
    auto num = ans;
    auto real_ans = ans;
    segtree2 R(real_ans);
    cnt = 1;
    int cnt_f = 0;
    bool flag = 1;
    bool is_barabarabara = 1;
    while (q--) {
        int type;
        cin >> type;
        cnt_f += (type == 1);
        if (type == 1) {
            int l, r, x;
            cin >> l >> r >> x;
            if (l == r) {
                int k = R.get_i(0, 0, n, l);
                if (k == 1) {
                    R.change(0, 0, n, num[l], num[l]+1, -Left[num[l]]-Right[num[r]]);
                    R.change(0, 0, n, num[l]+1, num[l]+Left[num[l]]+Right[num[l]]+1, 1);
                }
                else if (k == 0) {
                    R.change(0, 0, n, num[l], num[l]+1, -Left[num[r]]);
                    R.change(0, 0, n, num[l]+1, num[l]+Left[num[l]]+1, 1);
                }
                if (x == 1) {
                    R.change(0, 0, n, num[l], num[l]+1, Left[num[l]]+Right[num[r]]);
                    R.change(0, 0, n, num[l]+1, num[l]+Left[num[l]]+Right[num[l]]+1, -1);
                }
                else if (x == 0) {
                    R.change(0, 0, n, num[l], num[l]+1, Left[num[r]]);
                    R.change(0, 0, n, num[l]+1, num[l]+Left[num[l]]+1, -1);
                }
            } else
                is_barabarabara = 0;
            T.change(0, 0, n, l - 1, r, x);
            flag = 0;
        } else {
            int i;
            cin >> i;
            if (is_barabarabara) {
                cout << R.get_i(0, 0, n, num[i-1]) << '\n';
                continue;
            }
            if (!flag) {
                T.get(0, 0, n, t);
                obh(0, g, t, ans, cnt);
                cnt = 1;
                flag = 1;
            }
            cout << ans[i - 1] << '\n';
        }
    }
}