//JafoNoksy's code
#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pll = pair<ll, ll>;
#define ve vector
#define int ll
#define pb push_back
#define all(a) a.begin(), a.end()
#pragma GCC optimize "O2"
using str = string;

template<class A>
istream &operator>>(istream &in, ve<A> &x) {
    for (auto &el: x)
        in >> el;
    return in;
}

template<class A>
ostream &operator<<(ostream &out, ve<A> &x) {
    for (auto &el: x)
        out << el << ' ';
    return out << '\n';
}

struct segtree {
    ve<int> t;
    segtree (ve<int> &a) {
        t.resize(4*a.size());
        build(0, 0, a.size(), a);
    }
    void build(int v, int l, int r, ve<int> &a) {
        if (l+1 == r) {
            t[v] = a[l];
            return;
        }
        int m = (l+r)/2;
        build(2*v+1, l, m, a);
        build(2*v+2, m, r, a);
        t[v] = t[2*v+1] + t[2*v+2];
    }

    int find(int v, int l, int r, int _l, int _r) {
        if (_l >= _r)
            return 1e9;
        if (l >= _r || _l >= r)
            return 1e9;
        if (l+1 == r) {
            if (t[v] == 1)
                return l;
            else
                return 1e9;
        }
        int m = (l+r)/2;
        int k = find(2*v+1, l, m, _l, _r);
        if (k != 1e9)
            return k;
        return find(2*v+2, m, r, _l, _r);
    }

    int find(int l, int r) {
        return find(0, 0, t.size()/4, l, r);
    }
};

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    ve<int> a(n);
    cin >> a;
    ve<int> b(n, 0), c(n, 0), d(n, 0);
    for (int i = 0; i < n-1; ++i) {
        d[i] = a[i] == a[i+1];
        b[i] = a[i] > a[i+1];
    }
    for (int i = 1; i < n; ++i) {
        c[i] = a[i] > a[i-1];
    }
    segtree B(b), C(c), D(d);
    int ans = 0;
    for (int l = 0; l < n; ++l) {
        int r = min(n-1, D.find(l, n));
        int i = min(r, B.find(l, n));
        if (r < i) {
            ans += r-l+1;
            continue;
        }
        int j = C.find(i+1, n);
        r = min(r, j-1);
        ans += r-l+1;
    }
    cout << ans;
}
