//JafoNoksy's code
#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pll = pair<ll, ll>;
#define ve vector
#define int ll
#define pb push_back
#define F first
#define S second
#define all(a) a.begin(), a.end()
#pragma GCC optimize "O1"
#pragma GCC optimize "O2"
#pragma GCC optimize "O3"
using str = string;

template<class A>
istream &operator>>(istream &in, ve<A> &x) {
    for (auto &el: x)
        in >> el;
    return in;
}

template<class A>
ostream &operator<<(ostream &out, ve<A> &x) {
    for (auto &el: x)
        out << el << ' ';
    return out << '\n';
}

struct segtree {
    ve<int> t;
    segtree (ve<int> &a) {
        t.resize(4*a.size());
        build(0, 0, a.size(), a);
    }
    void build(int v, int l, int r, ve<int> &a) {
        if (l+1 == r) {
            if (a[l] == 1)
                t[v] = l;
            else
                t[v] = 1e9;
            return;
        }
        int m = (l+r)/2;
        build(2*v+1, l, m, a);
        build(2*v+2, m, r, a);
        t[v] = min(t[2*v+1], t[2*v+2]);
    }

    int find(int v, int l, int r, int _l, int _r) {
        if (_l >= _r)
            return 1e9;
        if (l >= _r || _l >= r)
            return 1e9;
        if (_l <= l && r <= _r) {
            return t[v];
        }
        int m = (l+r)/2;
        int k = find(2*v+1, l, m, _l, _r);
        if (k != 1e9)
            return k;
        return find(2*v+2, m, r, _l, _r);
    }

    int find(int l, int r) {
        return find(0, 0, t.size()/4, l, r);
    }
};
ve<int> p(16, -1);
bool can(ve<int> &a, int s, int l, int r) {
    if (s == 0)
        return true;
    for (int i = l; i < r && a[i] <= s; ++i) {
        if (can(a, s-a[i], i+1, r)) {
            p[l] = i+1;
            return true;
        }
    }
    return false;
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int h, w;
    cin >> h >> w;
    ve<ve<int>> a(h, ve<int>(w, 0));
    cin >> a;
    int H = (1 << h);
    int s; cin >> s;
    if (s > h*w*1e9) {
        cout <<"NO";
        return 0;
    }
    int W = (1 << w);
    ve<int> sum1(W);
    for (int m = 0; m < W; ++m) {
        for (int i = 0; i < w; ++i) {
            if ((m >> i) & 1) {
                for (int j = 0; j < h; ++j) {
                    sum1[m] += a[j][i];
                }
            }
        }
    }
    ve<int> sum(W/2 + 1);
    for (int mask = 0; mask <= H/2; ++mask) {
        ve<ll> b(w);
        for (int i = 0; i < h; ++i) {
            if (((mask >> i) & 1)) {
                for (int j = 0; j < w; ++j)
                    b[j] += a[i][j];
            }
        }
        int total = 0;
        for (auto &el : b)
            total += el;
        sum[0] = 0;
        int ansmask = -1;
        if (s == total) {
            ansmask = W-1;
        }
        for (int m = 1; m <= W/2; ++m) {
            for (int i = 0; i < w; ++i) {
                if ((m >> i) & 1) {
                    sum[m] = b[i] + sum[m-(1<<i)];
                    if (sum[m] == s) {
                        ansmask = m;
                    }
                    else if (total - sum[m] == s)
                        ansmask = W-1-m;
                    else if (sum1[m] - sum[m] == s) {
                        ansmask = m;
                        mask = H-1-mask;
                    } else if (sum1[W-1-m] - total + sum[m] == s) {
                        ansmask = W-1-m;
                        mask = H-1-mask;
                    }
                    break;
                }
            }
        }
        if (ansmask != -1) {
            cout << "YES\n";
            int i = 0;
            ve<pll> ans;
            for (int i = 0; i < h; ++i) {
                if (!((mask >> i) & 1))
                    ans.pb({1, i+1});
            }
            for (int i = 0; i < w; ++i) {
                if (!((ansmask >> i) & 1))
                    ans.pb({2, i+1});
            }
            cout << ans.size() << '\n';
            for (auto &&[x, y] : ans)
                cout << x << ' ' << y << '\n';
            return 0;
        }
    }
    cout << "NO";
}