//JafoNoksy's code
#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pll = pair<ll, ll>;
#define ve vector
#define int ll
#define pb push_back
#define F first
#define S second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#pragma GCC optimize "O3"
using str = string;

template<class A>
istream &operator>>(istream &in, ve<A> &x) {
    for (auto &el: x)
        in >> el;
    return in;
}

template<class A>
ostream &operator<<(ostream &out, ve<A> &x) {
    for (auto &el: x)
        out << el << ' ';
    return out << '\n';
}

int mx_dist(ve<ve<int>> &g, int v) {
    int n = g.size();
    ve<int> dist(n, -1);
    dist[v] = 0;
    queue<int> q;
    while (q.size()) {
        int v = q.front();
        q.pop();
        for (auto &u: g[v]) {
            if (dist[u] == -1) {
                dist[u] = dist[v] + 1;
                q.push(u);
            }
        }
    }
    return *max_element(all(dist));
}

void orient(int v, int p, ve<ve<int>> &g, ve<ve<int>> &newg) {
    for (auto &u: g[v]) {
        if (u != p) {
            newg[v].push_back(u);
            orient(u, v, g, newg);
        }
    }
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, k, t;
    cin >> n >> k >> t;
    ve<ve<int>> g(n);
    bool bambuk = 1;
    for (int i = 1; i < n; ++i) {
        int u, v;
        cin >> u >> v;
        if (u != v - 1)
            bambuk = false;
        g[u - 1].pb(v - 1);
        g[v - 1].pb(u - 1);
    }
    if (bambuk) {
        ve<int> ans(n);
        for (int i = 0; i < n; ++i) {
            int l = 0, r = n;
            int x = max(i, n - i - 1);
            r = x;
            if (k >= x) {
                ans[i] = 1;
                continue;
            }
            while (r - l > 1) {
                int m = (l + r) / 2;
                if ((m+1)*(m+2)/2 - 1 >= x && (k >= m || (k+1) * (m+1) - k * (k + 1) / 2> x))
                    r = m;
                else
                    l = m;
            }
            ans[i] = r;
        }
        if (t == 0) {
            cout << ans[0];
        } else {
            cout << ans;
        }
        return 0;
    }
    if (n <= 16) {
        int c = 0;
        for (int v = 0; v < n; ++v) {
            ve<ve<int>> nwg;
            orient(v, -1, g, nwg);
        }
    }
}